(document:surround "/std/base")

; note: label - for html, with +/- prefix
; here we use label2

(define (curr-obj) (form-value "selector"))

;; write down all settings via backend
(define (apply-to-backend url)
  (catch/message ( lambda ()
    (apply woo-write (string-append "/xinetd/" url) (form-value-list) )  ))
  (form-update-value "changed" #f))

;; reset all settings using data from backend
(define (reset-from-backend url)
  (form-update-value "changed" #f)
  (form-update-enum  "selector" (woo-list "/xinetd"))
  (form-update-value "selector" url)
  (form-update-value "common" (string=? url "__common_settings__"))

  (catch/message ( lambda ()
    (form-update-value-list
      `("description" "label2" "state" "user" "group" "server" "server_args" "rlimit_as"
        "instances" "per_source" "only_from" "bind" "type")
      (woo-read-first (string-append "/xinetd/" url) )) ))

  (form-update-value "label"
      (string-append
      "<b>" (form-value "label2")
      (if (form-value "type") (string-append " (" (_"internal service") ")") "") 
      "</b>" ))
    )

(define (change-item)
  (let ((cur (curr-obj)))
    (if (form-value "changed")
       (if (eq? 'yes (document:popup-question (_"There are unsaved changes in the service settings. Do you want to apply these changes?") 'yes 'no))
          (apply-to-backend (form-value "old-obj")) ))
    (reset-from-backend cur)
    (update-effect)
    (form-update-value "old-obj" cur)))


;; making widgets

(checkbox value #f visibility #f name "type")
(checkbox value #t visibility #f name "common")

(checkbox value #f visibility #f name "changed")
(edit     value "" visibility #f name "old-obj")
(edit     value "" visibility #f name "label2")

(splitbox columns "30;70"

  (listbox
    name    "selector"
    header  (vector (_ "Services"))
    row     '#((label2 . pic))
    enumref "/xinetd"
    current 0
    (when selected (change-item)) )

  (groupbox title ""
   (label name "label")
   (textbox "" alterability #f name "description")

   (gridbox columns "0;100"

    (spacer)
    (checkbox (_ "Enable service") name "state" (when changed (form-update-value "changed" #t)))

    (label text (_ "User:") align "right" name "user")
    (edit value "" name "user" (when changed (form-update-value "changed" #t)))

    (label text (_ "Group:") align "right" name "group")
    (edit value "" name "group" (when changed (form-update-value "changed" #t)))

    (label text (_ "Server:") align "right" name "server")
    (edit value "" name "server" (when changed (form-update-value "changed" #t)))

    (label text (_ "Server args:") align "right" name "server_args")
    (edit value "" name "server_args" (when changed (form-update-value "changed" #t)))

    (label text (_ "Rlimit as:") align "right" name "rlimit_as")
    (edit value "" name "rlimit_as" (when changed (form-update-value "changed" #t)))

    (label text (_ "Instances:") align "right" name "instances")
    (edit value "" name "instances" (when changed (form-update-value "changed" #t)))

    (label text (_ "Per source:") align "right" name "per_source")
    (edit value "" name "per_source" (when changed (form-update-value "changed" #t)))

    (label text (_ "Only from:") align "right" name "only_from")
    (edit value "" name "only_from" (when changed (form-update-value "changed" #t)))

    (label text (_ "Interface:") align "right" name "bind")
    (edit value "" name "bind" (when changed (form-update-value "changed" #t)))

    (spacer)
    (gridbox columns "0;0;100"
      (button (_ "Apply") (when clicked (let ((cur (curr-obj))) (apply-to-backend cur)
                                                                (reset-from-backend cur))))
      (button (_ "Reset") (when clicked (reset-from-backend (curr-obj))))
      (spacer) ))))

(document:root (when loaded
  (reset-from-backend (curr-obj))
  (form-update-value "old-obj" (curr-obj))
  (init-effect)
))

(effect-hide "state"       "common" #t)
(effect-hide "user"        "common" #t)
(effect-hide "group"       "common" #t)
(effect-hide "server"      "common" #t)
(effect-hide "server_args" "common" #t)
(effect-hide "rlimit_as"   "common" #t)
(effect-hide "bind"        "common" #t)

(effect-disable "user"        "state" #f)
(effect-disable "group"       "state" #f)
(effect-disable "server"      "state" #f)
(effect-disable "server_args" "state" #f)
(effect-disable "rlimit_as"   "state" #f)
(effect-disable "instances"   "state" #f)
(effect-disable "per_source"  "state" #f)
(effect-disable "only_from"   "state" #f)
(effect-disable "bind"        "state" #f)

(effect-hide "user"           "type" #t)
(effect-hide "group"          "type" #t)
(effect-hide "server"         "type" #t)
(effect-hide "server_args"    "type" #t)
(effect-show "internal_label" "type" #t)
